/***************************************************************************
 *                                                                         *
 *   PLIS COMPILER                                                         *
 *   =============                                                         *
 *                                                                         *
 *   Copyright (C) Juan Pedro Bolivar Puente 2007                          *
 *                                                                         *
 *   This program is free software: you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 *                                                                         *
 ***************************************************************************/

#include <libgen.h>

#include "misc.h"

using namespace std;

char* itoa(int val, int base)
{	
    static char buf[32] = {0};
    int i = 30;
    bool sign = val < 0;

    if (val == 0) {
	buf[30] = '0';
	return &buf[30];
    }
	
    if (sign) val = -val;
    
    for(; val && i ; --i, val /= base)
	buf[i] = "0123456789abcdef"[val % base];

    if (sign) buf[i--] = '-';

    return &buf[i+1];
}

string str_dirname(string str)
{
    string::iterator end = str.end();
    string::iterator beg;
    
    for (beg = --str.end(); beg != --str.begin() && *beg != '/'; --beg);
    str.erase(++beg, end);   
    return str;
}
